<?php

/**
 * PowerBB Engine - The Engine Helps You To Create Bulletin Board System.
 */

/**
 * @package 	: 	PowerBBSection
 * @author 		: 	Mohammed Q. Hussain <MaaSTaaR@gmail.com>
 * @updated 	: 	16/09/2008 03:43:15 AM
 */

class PowerBBSection
{
	var $id;
	var $Engine;

	function PowerBBSection($Engine)
	{
		$this->Engine = $Engine;
	}

	function InsertSection($param)
	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

		$query = $this->Engine->records->Insert($this->Engine->table['section'],$param['field']);

		if ($param['get_id'])
		{
			$this->id = $this->Engine->DB->sql_insert_id();
		}

		return ($query) ? true : false;
	}

 	function UpdateSection($param)
 	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

		$query = $this->Engine->records->Update($this->Engine->table['section'],$param['field'],$param['where']);
        @mysql_free_result($query);

		return ($query) ? true : false;
 	}

	function DeleteSection($param)
	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

		$param['table'] = $this->Engine->table['section'];

		$del = $this->Engine->records->Delete($param);

		return ($del) ? true : false;
	}

 	/**
 	 * Get sections by two ways
 	 *
 	 * @param : $get_from -> string : get sections from cache or from databese
 	 * @param : $des -> array : descript of many things
 	 *
 	 * @access public
 	 */
	function GetSectionsList($param)
 	{
  		if (!isset($param)
  			or !is_array($param))
 		{
 			$param = array();
 		}

 		$param['select'] 	= 	'*';
 		$param['from'] 		= 	$this->Engine->table['section'];

 		$rows = $this->Engine->records->GetList($param);

		return $rows;
 	}

 	/**
 	 * Get section information
 	 *
 	 * @access public
 	 */
	function GetSectionInfo($param)
	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

 	 	$param['select'] 	= 	'*';
 	 	$param['from'] 		= 	$this->Engine->table['section'];

		$rows = $this->Engine->records->GetInfo($param);
        @mysql_free_result($param);

		return $rows;
	}

	function GetSectionNumber($param)
 	{
  		if (!isset($param)
  			or !is_array($param))
 		{
 			$param = array();
 		}

 		$param['select'] 	= 	'*';
 		$param['from']		=	$this->Engine->table['section'];

 		$num = $this->Engine->records->GetNumber($param);

 		return $num;
 	}

 	function CheckPassword($param)
 	{
 		if (empty($param['id'])
 			or empty($param['password']))
 		{
 			trigger_error('ERROR::NEED_PARAMETER -- FROM CheckPassword() -- EMPTY id OR password',E_USER_ERROR);
 		}

 		$param['select'] 				= 	'*';
 		$param['from'] 					= 	$this->Engine->table['section'];
 		$param['where']					=	array();

 		$param['where'][0]				=	array();
 		$param['where'][0]['name'] 		= 	'id';
 		$param['where'][0]['oper'] 		= 	'=';
 		$param['where'][0]['value'] 	= 	$param['id'];

 		$param['where'][1]				=	array();
 		$param['where'][1]['con'] 		= 	'AND';
 		$param['where'][1]['name'] 		= 	'section_password';
 		$param['where'][1]['oper'] 		= 	'=';
 		$param['where'][1]['value'] 	= 	$param['password'];

      	$num = $this->Engine->records->GetNumber($param);

      	return ($num <= 0) ? false : true;
 	}

 	function UpdateLastSubject($param)
 	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

		$field = array(
		           		'last_writer'		=> 	$param['writer']		,
		           		'last_subject'		=>	$param['title']			,
		           		'last_subjectid'	=>	$param['subject_id']	,
		           		'last_date'			=>	$param['last_date']		,
		           		'last_time'			=>	$param['last_time']		,
		           		'linkvisitor'		=>	$param['linkvisitor']   ,
		           		'icon'		    	=>	$param['icon']			,
		           		'hide_subject'		=>	$param['hide_subject']	,
		           		'last_reply'		=>	$param['last_reply']    ,
		           		'section_password'	=>	$param['section_password']    ,
		           		'last_berpage_nm'	=>	$param['last_berpage_nm'],
		           		'forum_title_color'	=>	$param['forum_title_color'],
		           	   );

		$query = $this->Engine->records->Update($this->Engine->table['section'],$field,$param['where']);
 		return ($query) ? true : false;
 	}

	function CreateSectionsCache($param)
 	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

 		$arr 					= 	array();
 		$arr['get_from'] 		= 	'db';
 		$arr['type'] 			= 	'forum';
		$arr['order']			=	array();
		$arr['order']['field']	=	'sort';
		$arr['order']['type']	=	'ASC';
 		$arr['where'] 			= 	array('parent',$param['parent']);

 		$forums = $this->GetSectionsList($arr);

 			$x = 0;
 			$size = sizeof($forums);

 			$cache = array();

 			while ($x < $size)
 			{
 				$cache[$x] 							= 	array();
				$cache[$x]['id'] 					= 	$forums[$x]['id'];
				$cache[$x]['title'] 				= 	$forums[$x]['title'];
				$cache[$x]['section_describe'] 		= 	$forums[$x]['section_describe'];
				$cache[$x]['parent'] 				= 	$forums[$x]['parent'];
				$cache[$x]['sort'] 					= 	$forums[$x]['sort'];
				$cache[$x]['section_picture'] 		= 	$forums[$x]['section_picture'];
				$cache[$x]['sectionpicture_type'] 	= 	$forums[$x]['sectionpicture_type'];
				$cache[$x]['use_section_picture'] 	= 	$forums[$x]['use_section_picture'];
				$cache[$x]['linksection'] 			= 	$forums[$x]['linksection'];
				$cache[$x]['linkvisitor'] 			= 	$forums[$x]['linkvisitor'];
				$cache[$x]['last_writer'] 			= 	$forums[$x]['last_writer'];
				$cache[$x]['last_subject'] 			= 	$forums[$x]['last_subject'];
				$cache[$x]['last_subjectid'] 		= 	$forums[$x]['last_subjectid'];
				$cache[$x]['last_date'] 			= 	$forums[$x]['last_date'];
				$cache[$x]['last_time'] 			= 	$forums[$x]['last_time'];
				$cache[$x]['subject_num'] 			= 	$forums[$x]['subject_num'];
				$cache[$x]['reply_num'] 			= 	$forums[$x]['reply_num'];
				$cache[$x]['moderators'] 			= 	$forums[$x]['moderators'];
				$cache[$x]['icon'] 	        		=  	$forums[$x]['icon'];
				$cache[$x]['hide_subject'] 	        =  	$forums[$x]['hide_subject'];
				$cache[$x]['section_password'] 	    =  	$forums[$x]['section_password'];
				$cache[$x]['last_berpage_nm'] 	    =  	$forums[$x]['last_berpage_nm'];
				$cache[$x]['last_reply'] 	        =  	$forums[$x]['last_reply'];
				$cache[$x]['forums_cache'] 			= 	$forums[$x]['forums_cache'];
				$cache[$x]['forum_title_color']     = 	$forums[$x]['forum_title_color'];
				$cache[$x]['review_subject']        = 	$forums[$x]['review_subject'];
				$cache[$x]['replys_review_num']     = 	$forums[$x]['replys_review_num'];
				$cache[$x]['subjects_review_num']   = 	$forums[$x]['subjects_review_num'];
				$cache[$x]['groups'] 				= 	array();

 				$GroupArr 							= 	array();
 				$GroupArr['get_from'] 				= 	'db';
 				$GroupArr['order']					=	array();
 				$GroupArr['order']['field']			=	'id';
 				$GroupArr['order']['type']			=	'ASC';
 				$GroupArr['where'] 					= 	array('section_id',$forums[$x]['id']);

				$groups = $this->Engine->group->GetSectionGroupList($GroupArr);

				foreach ($groups as $group)
				{
					$cache[$x]['groups'][$group['group_id']] 					=	array();
					$cache[$x]['groups'][$group['group_id']]['view_section'] 	= 	$group['view_section'];
					$cache[$x]['groups'][$group['group_id']]['main_section'] 	= 	$group['main_section'];
				}

				$x += 1;
 			}

		$cache = base64_encode(serialize($cache));

		return $cache;
	}

 	function UpdateSectionsCache($param)
 	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}
          if (!$param['parent']== "0")
 	       {
		 		$cache = $this->CreateSectionsCache($param);
		     if ($cache)
			  {
			    $file_forums_cache = "cache/forums_cache_".$param['parent'].".php";
 				if (!file_exists($file_forums_cache))
 				{
			    $file_forums_cache = "../cache/forums_cache_".$param['parent'].".php";
 				}
				$fp = @fopen($file_forums_cache,'w');
				$Ds = '$';
				$parent = $param['parent'];
				$forums_cache = "<?php \n /*********************************\ \n DO NOT EDIT THIS FILE, PLEASE USE\n  THE forums_cache to forum num ($parent) \n\*********************************/\n\n\n\n ".$Ds."forums_cache = array( \n\n 'forums_cache' => '".$cache."', \n ); \n\n ?> ";

				$fw = @fwrite($fp,$forums_cache);
		        @fclose($fp);
		       }
 				if (!$fw)
 				{
 					$fail = true;
 				}
           }


 		return ($fail) ? true : false;
 	}

 	function UpdateAllSectionsCache()
 	{
 		$Sections = $this->GetSectionsList(null);

 		foreach ($Sections as $Section)
 		{
		 if ($Section['parent'] == '0')
 			{
 				$CacheArr 				= 	array();
 				$CacheArr['parent'] 	= 	$Section['id'];
 				 $Cache = $this->CreateSectionsCache($CacheArr);
		      if ($Cache)
 			  {
				   $file_forums_cache = "cache/section_cache_".$Section['id'].".php";
	 				if (!file_exists($file_forums_cache))
	 				{
				     $file_forums_cache = "../cache/section_cache_".$Section['id'].".php";
	 				}
					$fp = @fopen($file_forums_cache,'w');
					if (!$fp)
					{
					return 'ERROR::CAN_NOT_OPEN_THE_FILE';
					}
					$Ds = '$';
					$Section = $Section['id'];
					$forums_cache = "<?php /*********************************\ \n DO NOT EDIT THIS FILE, PLEASE USE\n  THE forums_cache to Section num ($Section)\n\*********************************/\n\n\n\n ".$Ds."forums_cache = array( \n\n 'forums_cache' => '".$Cache."', \n ); \n\n ?> ";

					$fw = @fwrite($fp,$forums_cache);
                     @fclose($fp);
               }
 				if (!$fw)
 				{
 					$fail = true;
 				}

 			}
 		}

 		return ($fail) ? false : true;
 	}

	function IsSection($param)
	{
 		if (!isset($param)
 			or !is_array($param))
 		{
 			$param = array();
 		}

		$param['select'] 	= 	'*';
		$param['from'] 		= 	$this->Engine->table['section'];

		$num = $this->Engine->records->GetNumber($param);

		return ($num <= 0) ? false : true;
	}

}

?>
